Attribute VB_Name = "CreateLimitSizes"
Public oProduct As Product
Public typeDoc As Variant
Public oPartDocument As PartDocument
Public oPart As Part
Public oBodies As Bodies
Public oBody As Body
Public oSelection As Selection
Public cMainBodyName As String


Sub CATMain()

    'On Error GoTo exitProc

    If NecessaryDocument Then
        CreateLimitModels
    End If
    
exitProc:
End Sub

Sub CreateLimitModels()
Dim cPasteBody As String
Dim lDelete As Boolean
Dim oBodyMax, oBodyMin, oTempBody As Body
Dim oShapes As Shapes
Dim oShape As Shape
Dim oSketches As Sketches
Dim oSketch As Sketch
Dim oConstraints As Constraints
Dim oConstraint As Constraint
Dim oDim1, oDim2 As Dimension
Dim nTolMax1, nTolMin1, nTolMax2, nTolMin2, nCnt As Variant


    lDelete = False
    If cMainBodyName = "" Then
        Set oPartDocument = CATIA.ActiveDocument
        Set oPart = oPartDocument.Part
        Set oBodies = oPart.Bodies
        If oBodies.Count = 1 Then
            cMainBodyName = oBodies.Item(1).Name
        End If
    Else
        Set oBodies = oSelection.Item(1).Value.Parent
        Set oPart = oSelection.Item(1).Value.Parent.Parent
        Set oPartDocument = oPart.Parent
    End If
 
    For Each oTempBody In oBodies
        If StrInStr("(MaxSize)", oTempBody.Name) <> 0 Then
            Set oBodyMax = oTempBody
            lDelete = True
        End If
        If StrInStr("(MinSize)", oTempBody.Name) <> 0 Then
            Set oBodyMin = oTempBody
            lDelete = True
        End If
    Next
 
 
    If Not lDelete Then
        Set oBody = oBodies.Item(cMainBodyName)
        oSelection.Clear
        oSelection.Add oBody
        oSelection.Copy
        ' Create body maximum sizes
        oSelection.Paste
        Set oBodyMax = oSelection.Item(1).Value
        oBodyMax.Name = oBodyMax.Name + " (MaxSize)"
        Set VisProperties = oSelection.VisProperties
        VisProperties.SetRealColor 255, 120, 120, 1
        ' Scan all shapes
        Set oShapes = oBodyMax.Shapes
        On Error Resume Next
        For nCnt = 1 To oShapes.Count
            Set oShape = oShapes.Item(nCnt)
            Select Case TypeName(oShape)
                Case "Pad"
                    Set oDim1 = oShape.FirstLimit.Dimension
                    Set oDim2 = oShape.SecondLimit.Dimension
                    nTolMax1 = oDim1.MaximumTolerance
                    nTolMin1 = oDim1.MinimumTolerance
                    nTolMax2 = oDim2.MaximumTolerance
                    nTolMin2 = oDim2.MinimumTolerance
                    oDim1.Value = oDim1.Value + nTolMax1
                    oDim2.Value = oDim2.Value + nTolMax2
                Case "Shaft"
                    nTolMax1 = oShape.FirstAngle.MaximumTolerance
                    nTolMin1 = oShape.FirstAngle.MinimumTolerance
                    nTolMax2 = oShape.SecondAngle.MaximumTolerance
                    nTolMin2 = oShape.SecondAngle.MinimumTolerance
                    oShape.FirstAngle.Value = oShape.FirstAngle.Value + nTolMax1
                    oShape.SecondAngle.Value = oShape.SecondAngle.Value + nTolMax2
            End Select
            If Err <> 0 Then
                Err.Clear
            End If
        Next
        ' Scan all sketches
        Set oSketches = oBodyMax.Sketches
        For Each oSketch In oSketches
            Set oConstraints = oSketch.Constraints
            For Each oConstraint In oConstraints
                Select Case oConstraint.Type
                    Case catCstTypeRadius, catCstTypeDistance, catCstTypeLength
                        Set oDim1 = oConstraint.Dimension
                        nTolMax1 = oDim1.MaximumTolerance
                        nTolMin1 = oDim1.MinimumTolerance
                        oDim1.Value = oDim1.Value + nTolMax1
                        If Err <> 0 Then
                            Err.Clear
                        End If
                End Select
            Next
        Next
        On Error GoTo 0
        ' Create body minimum sizes
        oSelection.Clear
        oSelection.Add oBody
        oSelection.Paste
        Set oBodyMin = oSelection.Item(1).Value
        oBodyMin.Name = oBodyMin.Name + " (MinSize)"
        Set VisProperties = oSelection.VisProperties
        VisProperties.SetRealColor 0, 194, 47, 1
        Set oShapes = oBodyMin.Shapes
        On Error Resume Next
        For nCnt = 1 To oShapes.Count
            Set oShape = oShapes.Item(nCnt)
            Select Case TypeName(oShape)
                Case "Pad"
                    Set oDim1 = oShape.FirstLimit.Dimension
                    Set oDim2 = oShape.SecondLimit.Dimension
                    nTolMax1 = oDim1.MaximumTolerance
                    nTolMin1 = oDim1.MinimumTolerance
                    nTolMax2 = oDim2.MaximumTolerance
                    nTolMin2 = oDim2.MinimumTolerance
                    oDim1.Value = oDim1.Value + nTolMin1
                    oDim2.Value = oDim2.Value + nTolMin2
                Case "Shaft"
                    nTolMax1 = oShape.FirstAngle.MaximumTolerance
                    nTolMin1 = oShape.FirstAngle.MinimumTolerance
                    nTolMax2 = oShape.SecondAngle.MaximumTolerance
                    nTolMin2 = oShape.SecondAngle.MinimumTolerance
                    oShape.FirstAngle.Value = oShape.FirstAngle.Value + nTolMin1
                    oShape.SecondAngle.Value = oShape.SecondAngle.Value + nTolMin2
            End Select
            If Err <> 0 Then
                Err.Clear
            End If
        Next
        ' Scan all sketches
        Set oSketches = oBodyMin.Sketches
        For Each oSketch In oSketches
            Set oConstraints = oSketch.Constraints
            For Each oConstraint In oConstraints
                Select Case oConstraint.Type
                    Case catCstTypeRadius, catCstTypeDistance, catCstTypeLength
                        Set oDim1 = oConstraint.Dimension
                        nTolMax1 = oDim1.MaximumTolerance
                        nTolMin1 = oDim1.MinimumTolerance
                        oDim1.Value = oDim1.Value + nTolMin1
                        If Err <> 0 Then
                            Err.Clear
                        End If
                End Select
            Next
        Next
        On Error GoTo 0
        oPart.Update
    Else
        On Error Resume Next
        oSelection.Clear
        oSelection.Add oBodyMin
        oSelection.Delete
        oSelection.Clear
        oSelection.Add oBodyMax
        oSelection.Delete
        On Error GoTo 0
    End If
    cMainBodyName = ""
    
End Sub

Public Function NecessaryDocument()
    NecessaryDocument = False
    On Error GoTo SkipCode
    typeDoc = TypeName(CATIA.ActiveDocument)
    '
    Select Case typeDoc
        Case "PartDocument"
            Set oProduct = CATIA.ActiveDocument.Product
            Set oSelection = CATIA.ActiveDocument.Selection
            NecessaryDocument = True
        Case "ProductDocument"
            Set oSelection = CATIA.ActiveDocument.Selection
            If oSelection.Count = 0 Then
                MsgBox "!" & Chr(13) & " Part      ", _
                vbExclamation, "CATScript Message:"
                GoTo SkipCode
            Else
                If oSelection.Count > 1 Then
                    MsgBox "!" & Chr(13) & "  Part   !  .", _
                    vbExclamation, "CATScript Message:"
                    GoTo SkipCode
                Else
                    If TypeName(oSelection.Item(1).Value) = "Body" Then
                        cMainBodyName = oSelection.Item(1).Value.Name
                        Set oProduct = CATIA.ActiveDocument.Product
                        NecessaryDocument = True
                    
                    Else
                        MsgBox "!" & Chr(13) & "     !   .", _
                        vbExclamation, "CATScript Message:"
                        GoTo SkipCode
                    End If
                End If
            End If
            
            
    End Select
    
SkipCode:

    On Error GoTo 0
End Function

